!DIR$ FIXEDFORMLINESIZE:132
      pure subroutine make_muz(cq, b, mu, iord)
      use dblocks
      implicit none
      complex*16, intent(in)  :: cq(1:3)
      complex*16, intent(in)  :: b(1:3,-Lz:Lz,-Ly:Ly,-Lx:Lx)
      complex*16, intent(out) :: mu(0:nord)
      integer*4 , intent(out) :: iord

      complex*16, dimension(1:3,-Lz:Lz,-Ly:Ly,-Lx:Lx) :: b_im2, b_im1, b_i, a_i
      complex*16 s_im1, s_i
      integer*4 i

      interface
         pure subroutine make_sz(b, s)
         use dblocks
         complex*16, intent(in)  :: b(1:3,-Lz:Lz,-Ly:Ly,-Lx:Lx)
         complex*16, intent(out) :: s
         end subroutine make_sz

         pure subroutine mult_W(cq, a, b)
         use dblocks
         complex*16, intent(in)  :: cq(1:3)
         complex*16, intent(in)  ::  a(1:3,-Lz:Lz,-Ly:Ly,-Lx:Lx)
         complex*16, intent(out) ::  b(1:3,-Lz:Lz,-Ly:Ly,-Lx:Lx)
         end subroutine mult_W
      end interface

      mu    = cz
      b_im2 = cz
      b_im1 = cz
      s_im1 = ru

      i   = 0
      b_i = b
      call make_sz(b_i, s_i)
      if(cdabs(s_i) .lt. sthr) then
         iord = i-1
         return
      end if
      mu(i) = s_i / s_im1

      do 1, i=1,nord
         b_im2 = b_im1
         b_im1 = b_i
         s_im1 = s_i
         a_i   = b_im1 - mu(i-1)*b_im2
         call mult_W(cq, a_i, b_i)
         call make_sz(b_i, s_i)
         if(cdabs(s_i) .lt. sthr) then
            iord = i-1
            return
         end if
         mu(i) = s_i / s_im1
         if(cdabs(mu(i)) .gt. mthr) then
            iord = i
            return
         end if
 1    continue

      iord = nord
      
      return
      end
