!DIR$ FIXEDFORMLINESIZE:132
      pure subroutine solve_fixP(Mode, Niter, cq_ini, cq_sol, info)
      use dblocks
      implicit none
      integer*4,  intent(in)  :: Mode, Niter
      complex*16, intent(in)  :: cq_ini(1:3)
      complex*16, intent(out) :: cq_sol(1:3)
      integer*4 , intent(out) :: info

      complex*16 cF, cqz, cq(1:3)
      real*8     test
      integer*4  iter

c      external make_CF

      interface
         pure subroutine make_cF(Mode, cq, cF)
         use dblocks
         integer*4,  intent(in)    :: Mode
         complex*16, intent(inout) :: cq(1:3)
         complex*16, intent(out)   :: cF
         end subroutine make_cF
      end interface

      cq = cq_ini
      
      do 1, iter=1,Niter

      cqz = cq(3)
      call make_cF(Mode, cq, cF)
      test = cdabs(cqz*cqz - rk2*cF)

      if(test .le. eps) then
         cq(3)  = cqz
         cq_sol = cq
         info   = iter
         return
      end if

      cq(3)  = rk * cdsqrt(cF)

 1    continue

      info = -1
      return

      end
